//-------------------------------------------------------------------------
// sending async messages to emacs-server.
// for me, "server" sounds like some kind of geek term, but infact all
// i have to do is add (server-start) to my orged.el file.
//
// build it like : gcc main.c -lwtsapi32
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
// msconfig.h stuff
//-------------------------------------------------------------------------


// contains stdafx.h and other definitions.
#define WINVER   0x0501
#define WIN32_LEAN_AND_MEAN

// includes.
#include <windows.h>
#include <wtsapi32.h>


//-------------------------------------------------------------------------
// main program.
//-------------------------------------------------------------------------


// synchronizing event.
static HANDLE  hEvent;

static LRESULT OnWtsSessionChange(HWND hWnd, WPARAM wEventType)
{
   TCHAR szCmdlineOnLock[] = 
      TEXT("C:\\cygwin\\usr\\local\\nt-emacs\\bin\\emacsclientw -e \"(org-win-lock)\"");
   TCHAR szCmdlineOnUnlock[] = 
      TEXT("C:\\cygwin\\usr\\local\\nt-emacs\\bin\\emacsclientw -e \"(org-win-unlock)\"");

   PROCESS_INFORMATION piProcInfo; 
   STARTUPINFO siStartInfo;
 
   ZeroMemory( &piProcInfo, sizeof(PROCESS_INFORMATION) );
   ZeroMemory( &siStartInfo, sizeof(STARTUPINFO) );
   siStartInfo.cb = sizeof(STARTUPINFO); 
   siStartInfo.hStdError = NULL;
   siStartInfo.hStdOutput = NULL;
   siStartInfo.hStdInput = NULL;
   siStartInfo.dwFlags |= STARTF_USESTDHANDLES;

   TCHAR* cmdLine = NULL;
 
   switch (wEventType)
   {
   case WTS_SESSION_LOCK :
      cmdLine = szCmdlineOnLock;
      break;

   case WTS_SESSION_UNLOCK :
      cmdLine = szCmdlineOnUnlock;
      break;

   case WTS_SESSION_LOGOFF :
      SetEvent(hEvent);
      DestroyWindow(hWnd);
      break;
   }

   CreateProcess(NULL, cmdLine, NULL, NULL, TRUE, 0, NULL, NULL,
                 &siStartInfo, &piProcInfo);

   return 0;
}


static LRESULT CALLBACK 
WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
   LRESULT result = 0;
   switch (message)
   {
   case WM_WTSSESSION_CHANGE :
      result = OnWtsSessionChange(hWnd, wParam);
      break;

   case WM_DESTROY :
      PostQuitMessage (1);
      break;
   }

   result = DefWindowProc(hWnd, message, wParam, lParam);
   return result;
}


static DWORD WINAPI fnWaitForWtsNotifs(LPVOID lpParam)
{
   WNDCLASS wc;
   HWND hWnd;
   MSG msg;
   HANDLE hInstance = GetModuleHandle(NULL);

   wc.style = 0;                                   // Class style
   wc.lpfnWndProc = (WNDPROC) WndProc;             // Window procedure
   wc.cbClsExtra = 0;                              // Class extra bytes
   wc.cbWndExtra = 0;                              // Window extra bytes
   wc.hInstance = (HINSTANCE)hInstance;            // Instance handle
   wc.hIcon = LoadIcon (NULL, IDI_WINLOGO);        // Icon handle
   wc.hCursor = LoadCursor (NULL, IDC_ARROW);      // Cursor handle
   wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1); // Background color
   wc.lpszMenuName = NULL;                         // Menu name
   wc.lpszClassName = "MyWndClass";                // WNDCLASS name

   RegisterClass(&wc);
   hWnd = 
      CreateWindow (
         "MyWndClass",            // WNDCLASS name
         "RegisterApplication",   // Window title
         WS_OVERLAPPEDWINDOW,     // Window style
         CW_USEDEFAULT,           // Horizontal position
         CW_USEDEFAULT,           // Vertical position        
         CW_USEDEFAULT,           // Initial width
         CW_USEDEFAULT,           // Initial height
         HWND_MESSAGE,            // HWND_DESKTOP, Handle of parent window
         NULL,                    // Menu handle
         NULL,                    // Application's instance handle
         NULL                     // Window-creation data
         );

   // register for wts notifications.
   if ( ! WTSRegisterSessionNotification(hWnd, NOTIFY_FOR_ALL_SESSIONS) )
   {
      printf("WTSRegisterSessionNotification failed");
      return -1;
   }

   while ( GetMessage(&msg, NULL, 0, 0) )
   {
      TranslateMessage( &msg );
      DispatchMessage( &msg );
   }

   WTSUnRegisterSessionNotification(hWnd);
   return msg.wParam;
}


int main()
{
   HANDLE hThread;
   DWORD dwId;

   // create a thread, wait for notificatons.
   hThread = CreateThread( NULL, 0, fnWaitForWtsNotifs, NULL, 0, &dwId);
   if (NULL == hThread) { return -1; }

   hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
   if (INVALID_HANDLE_VALUE == hEvent) { return -1; }
   WaitForSingleObject(hEvent, INFINITE);
   CloseHandle(hEvent);

   printf("exiting");

   return 0;
}
